using PkmnLib.Plugin.Gen7.Scripts.Pokemon;

namespace PkmnLib.Plugin.Gen7.Scripts.Moves;

[Script(ScriptCategory.Move, "sky_drop")]
public class SkyDrop : Script, IScriptPreventMove, IScriptOnBeforeMove
{
    /// <inheritdoc />
    public void PreventMove(IExecutingMove move, ref bool prevent)
    {
        if (move.User.Volatile.Contains<ChargeSkyDropEffect>())
            return;

        move.User.Volatile.Add(new ChargeSkyDropEffect(move.User));
        move.MoveChoice.SetAdditionalData("sky_drop_charge", true);
        move.User.BattleData?.Battle.EventHook.Invoke(new DialogEvent("sky_drop_charge", new Dictionary<string, object>
        {
            { "user", move.User },
        }));
        prevent = true;
    }

    /// <inheritdoc />
    public void OnBeforeMove(IExecutingMove move)
    {
        move.User.Volatile.Remove(ScriptUtils.ResolveName<ChargeSkyDropEffect>());
    }
}